﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FR.SAFTAnalyser.SAFT
{
    public class SaftFiles
    {
        #region Singleton
        private static volatile SaftFiles instance;
        private static object syncRoot = new Object();

        private SaftFiles() { }

        public static SaftFiles Instance
        {
            get
            {
                if (instance == null)
                {
                    lock (syncRoot)
                    {
                        if (instance == null)
                            instance = new SaftFiles();
                    }
                }

                return instance;
            }
        } 
        #endregion

        public string SaftFileName { get; set; }

        public string SchemaFileName { get; set; }

        public string PublicKeyFileName { get; set; }
    }
}
